// TEN HTML5 version
// (c) 2014 Cybermuse
// Arranger 古籏一浩
var score = 0;			// スコア（得点）を入れる変数
var count = 0;		// ボタンの合計を入れる変数
var prevNumber = 0;	// 直前にクリックした数字を入れる変数
var prevNumberX;	// 直前にクリックした数字のX座標を入れる変数
var prevNumberY;	// 直前にクリックした数字のY座標を入れる変数
var prevPtr;	// 直前にクリックした数字の配列内での位置を入れる変数
var time = 0;	// ゲームオーバーまでの時間
var timerID = null;	// カウントダウンタイマーのIDを入れる変数
var firstClickFlag = false;	// 最初にクリックしたかどうかのフラグ
var gameFlag = true;	// ゲーム中かどうかのフラグ。trueならゲーム中。
var num = [ ];	// 数字を入れる配列変数を用意
var numXCount = 4;	// 横の数字の個数
var numYCount = 6;	// 縦の数字の個数
var canvas = document.getElementById("stage");	// ●canvas要素を取得する
var ctx = canvas.getContext("2d");	// ●2dコンテキストを取得する
// 初期化処理
function init(){
	canvas.onclick = addNumber;	// canvas要素にクリックイベントを割り当てる
	count = setRandomValue(numXCount, numYCount);	// 戻り値は要素の総数
	time = 30;	// 30秒に設定する
	document.getElementById("timeString").innerHTML = time + "秒";	// 時間を表示する
}
// ランダムに値を設定する関数
function setRandomValue(w, h){
	num = [ ];	// 配列内容を消去する
	var len = w * h;	// 数字の総数
	// ランダムな値を設定する
	for(var i=0; i<len; i+=2){	// 数字の数だけ繰り返す
		var n = Math.floor(Math.random() * 9) + 1;	// 1〜9までの数値をランダムに生成する
		num.push(n);
		num.push(10 - n);
	}
	// 配列要素をシャッフルする
	for(var i=0; i<len; i++){
		var p1 = Math.floor(Math.random() * len);	// 要素の数の範囲で乱数を発生させる
		var p2 = Math.floor(Math.random() * len);	// 要素の数の範囲で乱数を発生させる
		var n = num[p1];	// 2つの要素の内容を入れ替える
		num[p1] = num[p2];
		num[p2] = n;
	}
	// 表示処理
	document.getElementById("clearMsg").style.visibility = "hidden";	// ステージクリアメッセージを消す
	for(var y=0; y<h; y++){	// 数字の数だけ繰り返す
		for(var x=0; x<w; x++){
			drawNumber(num[x+y*w], x*48, y*48);
		}
	}
	return len;	// 数字の総数を返す
}
// 数字を指定座標に描画する
function drawNumber(n, x, y, opacity){
	if (!opacity){ opacity = 1.0; }	// ●不透明度が指定されていない場合は100%の不透明度にする
	var imgObj = document.getElementById("N"+n);	// ●HTMLファイル内の画像を指定する
	var saveOpacity = ctx.globalAlpha;	// ●現在の不透明度を変数に保存する
	ctx.globalAlpha = opacity;	// ●不透明度を設定する
	ctx.drawImage(imgObj, x, y);	// ●指定した座標に数字の画像を描画する
	ctx.globalAlpha = saveOpacity;	// ●元の不透明度に戻す
}
// 指定座標の範囲を消す
function eraseNumber(x, y){
	ctx.clearRect(x, y, 48, 48);	// 指定された範囲を消す
}
// 2つの数字の合計が10かどうか調べる
function addNumber(evt){
	// ゲーム中かどうかを調べる
	if (gameFlag === false){ return; }	// ゲーム中でない場合は以後の処理をしない
	// 初めてのクリックかどうか調べる
	if (firstClickFlag === false){
		firstClickFlag = true;	// クリックされたらtrueにする
		timerID = setInterval("displayTimer()", 1000);	// 1秒ごと定期的にタイマー表示関数を呼び出す
	}
	// クリック座標を求める
	var clickX = parseInt(evt.offsetX / 48);
	var clickY = parseInt(evt.offsetY / 48);
	var ptr = clickX + clickY*numXCount;	// 数字の配列内の位置を計算する
	var clickNum = num[ptr];	// 配列から数字を読み出す
	if (!clickNum){ return; } 	// 数字以外の範囲をクリックした場合は以後の処理をしない
	// 1個目のクリックの場合
	if (prevNumber === 0){
		prevNumber = clickNum;	// クリックされた数字を変数に入れる
		prevNumberX = clickX;	// クリックされた数字のX座標を変数に入れる
		prevNumberY = clickY;	// クリックされた数字のY座標を変数に入れる
		prevPtr = ptr;	// クリックされた数字の配列内での位置を変数に入れる
		eraseNumber(clickX*48, clickY*48);	// 現在の数字を消す
		drawNumber(clickNum, clickX*48, clickY*48, 0.5);	// 現在の数字を半透明で表示する
		return;	// 関数から抜ける
	}
	// 2個目のクリックの場合
	var total = prevNumber + parseInt(clickNum);	// 直前の数値とクリックされた数値を加算する
	if (total === 10){	// 合計が10の場合の処理
		eraseNumber(clickX*48, clickY*48);	// 現在の数字を非表示にする
		eraseNumber(prevNumberX*48, prevNumberY*48);	// 前にクリックした数字を非表示にする
		num[prevPtr] = null;	// 直前の数字を消す。忘れると何度もクリックできてしまう
		num[ptr] = null;	// 数字を消す。忘れると何度もクリックできてしまう
		prevNumber = 0;	// 数値を0にする
		score = score + 1;	// スコア（得点）を追加する
		document.getElementById("score").innerHTML = score;	// スコア（得点）を表示する
		count = count - 2;	// 合計から2を引く
		if (count === 0){	// 全部消したかどうか調べる
			document.getElementById("clearMsg").style.visibility = "visible";	// ステージクリアメッセージを表示する
			clearInterval(timerID);	// タイマーを停止する
			setTimeout(function(){	// 2秒後に表示されているメッセージを消すためのタイマー
				count = setRandomValue(numXCount, numYCount);	// 乱数値を設定する
				timerID = setInterval("displayTimer()", 1000);	// 1秒ごと定期的にタイマー表示関数を呼び出す
			}, 2000);
		}
		return;	// 関数から抜ける
	}
	// 合計が10でなかった場合
	eraseNumber(prevNumberX*48, prevNumberY*48);	// ●前にクリックした数字を消す
	drawNumber(prevNumber, prevNumberX*48, prevNumberY*48);	// ●前にクリックした数字を表示する
	prevNumber = 0;	// 数値を0にする
}
// タイマーの表示処理
function displayTimer(){
	time = time - 1;
	document.getElementById("timeString").innerHTML = time + "秒";
	if (time < 1){	// 時間が1より少なくなったらゲームオーバー
		gameFlag = false;	// ゲーム停止をフラグで示す。falseならゲーム中ではない
		clearInterval(timerID);	// タイマーを停止する
		alert("ゲームオーバー");
	}
}
window.onload = init;	// ●データが完全に読み込まれたら初期化処理を呼び出す
